(function($, Drupal) {

    Drupal.behaviors.logout_timeout = {
        attach: function (context, settings) {

            let baseUrl = drupalSettings.path.baseUrl;

            let localSettings;
            localSettings = jQuery.extend(true, {}, settings.logout_timeout);

            let maxInactivitySeconds = localSettings.maxInactivitySeconds;
            let inactivityDialogDuration = localSettings.inactivityDialogDuration;
            let dialogTitle = localSettings.dialogTitle;
            let dialogMessage = localSettings.dialogMessage;
            let stayLoggedInButtonText = localSettings.stayLoggedInButtonText;
            let logoutNowButtonText = localSettings.logoutNowButtonText;
            let debugJavascript = localSettings.debugJavascript;

            let idleHandDiag = document.getElementById('logout-timeout-window');
            if (!idleHandDiag) {
                new IdleHands({
                    events: ['scroll', 'change', 'keypress', 'keyup', 'mousedown', 'wheel', 'contextmenu', 'auxclick', 'touchmove'],
                    applicationId: 'logoutTimeout',
                    maximumIdleDuration: maxInactivitySeconds * 1000,
                    duration: inactivityDialogDuration * 1000,
                    dialogText: dialogMessage,
                    headerText: dialogTitle,
                    containerTitle: dialogTitle,
                    documentTitle: dialogTitle,
                    heartbeatUrl: window.location.href,
                    heartbeatInterval: 120 * 1000,
                    logoutUrl: baseUrl + 'logout-timeout/1',
                    logoutButtonText: logoutNowButtonText,
                    manualLogoutUrl: baseUrl + 'logout-timeout/0',
                    cancelButtonText: stayLoggedInButtonText,
                    debug: debugJavascript,
                });
            }

        }
    }

})(jQuery, Drupal);
